#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define PRINT(v, n) { \
  printf("" # v " - line %d > ", __LINE__); \
  for (int i=0; i < n; i++) { \
    printf(" %02X", v[i]); \
  } \
  putchar('\n'); \
}

int main(int argc, char** argv) {
  int n;  unsigned char *a, *b;
  --argc; ++argv;
  n = argc == 1 ? atoi(argv[0]) : 10;
  a = (char*) malloc(n);   // allocate memory for a
  memset(a, 'x', n);       // set all positions to 'x'
  PRINT(a, n);             // print contents
  free(a);                 // free memory

  // a is now a dangling reference (to freed up memory) 
  b = (char*) malloc(2*n);  // allocate memory for b
  printf("a == b ? %s\n", a == b ? "yes" : "no");
  PRINT(a, n); PRINT(b,2*n); // print contents of invalid a & initial b
  memset(b, 'X', 2*n);       // set all positions to 'X'
  PRINT(a, n); PRINT(b,2*n); // print again
  memset(a, 'x', n);         // use dangling reference, set to 'x'
  PRINT(a, n); PRINT(b,2*n); // print again
  // no free for b ? -> memory leak
  return 0;
}
